%{

#include <stdio.h>
#include <string.h>
#include <math.h>
#include <stdlib.h>
#include "ast.h"

extern int yylex();
extern int yyerror(char*);
extern void lexinit(FILE*);

static int c=1,cmax=1; 
static int newBB=0;
static int idxBB=0;

int sl(int i) {
  if (i<0) {
    printf("ERROR: %d<0",i);
    exit(-1);
  }
  if (i==0) return 1;
  else return ceil(log10(i+1));
}

%}

%token VARREF CONSTANT SIN IF WHILE

%left '+' 
%left '*' 

%%

code : sequence_of_statements
  {
    for (c=1;c<cmax;c++) printf("double v%d, v%d_;\n",c,c);
    printf("%s",$1.af);
    free($1.af);
    int i;
    printf("int i_;\n");
    printf("while (pop_c(i_)) {\n");
    for (i=0;i<=idxBB;i++) {
      if (i==0) 
        printf("if");
      else
        printf("else if");
      if ($1.ar[i]) 
        printf(" (i_==%d) {\n%s}\n",i,$1.ar[i]);
      else
        printf(" (i_==%d) {\n}\n",i);
      free($1.ar[i]);
    }
    printf("}\n");
  }

  ;
sequence_of_statements : statement { $$=$1; }/*@\label{p1b2}@*/
  | statement sequence_of_statements/*@\label{p2b2}@*/
  {
    $$.af=(char*)malloc((strlen($1.af)+strlen($2.af)+1)*sizeof(char)); 
    sprintf($$.af,"%s%s",$1.af,$2.af);
    free($2.af); free($1.af);

    int i;
    for (i=0;i<=idxBB;i++) {
      if ($2.ar[i]&&$1.ar[i]) {
        $$.ar[i]=(char*)malloc((strlen($1.ar[i])+strlen($2.ar[i])+1)*sizeof(char));
        sprintf($$.ar[i],"%s%s",$2.ar[i],$1.ar[i]);
        free($2.ar[i]); free($1.ar[i]); 
      }
      else if ($2.ar[i]) {
        $$.ar[i]=(char*)malloc((strlen($2.ar[i])+1)*sizeof(char));
        sprintf($$.ar[i],"%s",$2.ar[i]);
        free($2.ar[i]); 
      }
      else if ($1.ar[i]) {
        $$.ar[i]=(char*)malloc((strlen($1.ar[i])+1)*sizeof(char));
        sprintf($$.ar[i],"%s",$1.ar[i]);
        free($1.ar[i]); 
      }
    }
  }
  ;/*@\label{p2e2}@*/
statement : assignment { $$=$1; }
  | if_statement { $$=$1; }
  | while_statement { $$=$1; }
  ;
if_statement : IF '(' condition ')' '{' /*@\label{p8b2}@*/
  {
    newBB=1; 
  }
  sequence_of_statements '}'
  {
    $$.af=(char*)malloc((strlen($3.af)+strlen($7.af)+12)*sizeof(char)); 
    sprintf($$.af,"if (%s) {\n%s}\n",$3.af,$7.af);
    free($3.af); free($7.af); 
    int i;
    for (i=0;i<=idxBB;i++) {
      if ($7.ar[i]) {
        $$.ar[i]=(char*)malloc((strlen($7.ar[i])+1)*sizeof(char));
        sprintf($$.ar[i],"%s",$7.ar[i]);
        free($7.ar[i]);
      }
    }
    newBB=1;
  }
  ;/*@\label{p8e2}@*/
while_statement : WHILE '(' condition ')' '{' /*@\label{p9b2}@*/
  {
    newBB=1;
  }
  sequence_of_statements '}'
  {
    $$.af=(char*)malloc((strlen($3.af)+strlen($7.af)+15)*sizeof(char)); 
    sprintf($$.af,"while (%s) {\n%s}\n",$3.af,$7.af);
    free($3.af); free($7.af);
    int i;
    for (i=0;i<=idxBB;i++) {
      if ($7.ar[i]) {
        $$.ar[i]=(char*)malloc((strlen($7.ar[i])+1)*sizeof(char));
        sprintf($$.ar[i],"%s",$7.ar[i]);
        free($7.ar[i]);
      }
    }
    newBB=1;
  }
  ; /*@\label{p9e2}@*/
condition : VARREF '<' VARREF /*@\label{p10b2}@*/
  {
    $$.af=(char*)malloc((strlen($1.af)+strlen($3.af)+2)*sizeof(char)); 
    sprintf($$.af,"%s<%s",$1.af,$3.af);
    free($1.af); free($3.af); 
  }/*@\label{p10e2}@*/
assignment : VARREF '=' /*@\label{p3b2}@*/
  {
    if (newBB) idxBB++; 
  }
  expression ';'
  { 
    if (newBB||!idxBB) { 
      $$.af=(char*)malloc((strlen($4.af)+sl(idxBB)+3*strlen($1.af)+2*sl($4.j)+24)*sizeof(char)); 
      sprintf($$.af,"push_c(%d);\n%spush_v(%s); %s=v%d;\n",idxBB,$4.af,$1.af,$1.af,$4.j);
    }
    else {
      $$.af=(char*)malloc((strlen($4.af)+3*strlen($1.af)+2*sl($4.j)+15)*sizeof(char)); 
      sprintf($$.af,"%spush_v(%s); %s=v%d;\n",$4.af,$1.af,$1.af,$4.j);
    }
    $$.ar[idxBB]=(char*)malloc((3*strlen($1.af)+sl($4.j)+strlen($4.ar[idxBB])+21)*sizeof(char));
    sprintf($$.ar[idxBB],"pop_v(%s); v%d_=%s_; %s_=0;\n%s",$1.af,$4.j,$1.af,$1.af,$4.ar[idxBB]);
    free($4.ar[idxBB]);
    newBB=0;
    free($1.af); free($4.af);
    c=1;
  }
  ;/*@\label{p3e2}@*/
expression : expression '*' expression
  {
    $$.j=c++; if (c>cmax) cmax=c; 
    $$.af=(char*)malloc((strlen($1.af)+strlen($3.af)+2*sl($$.j)+sl($1.j)+sl($3.j)+17)*sizeof(char)); 
    sprintf($$.af,"%s%spush_v(v%d); v%d=v%d*v%d;\n",$1.af,$3.af,$$.j,$$.j,$1.j,$3.j);
    free($1.af); free($3.af);

    $$.ar[idxBB]=(char*)malloc((2*sl($1.j)+2*sl($3.j)+3*sl($$.j)+strlen($1.ar[idxBB])+strlen($3.ar[idxBB])+29)*sizeof(char));
    sprintf($$.ar[idxBB],"pop_v(v%d); v%d_=v%d_*v%d; v%d_=v%d_*v%d;\n%s%s",$$.j,$1.j,$$.j,$3.j,$3.j,$$.j,$1.j,$3.ar[idxBB],$1.ar[idxBB]);
    free($1.ar[idxBB]); free($3.ar[idxBB]);

  }
  | expression '+' expression
  {
    $$.j=c++; if (c>cmax) cmax=c; 
    $$.af=(char*)malloc((strlen($1.af)+strlen($3.af)+2*sl($$.j)+sl($1.j)+sl($3.j)+19)*sizeof(char)); 
    sprintf($$.af,"%s%spush_v(v%d); v%d=v%d+v%d;\n",$1.af,$3.af,$$.j,$$.j,$1.j,$3.j);
    free($1.af); free($3.af);

      $$.ar[idxBB]=(char*)malloc((2*sl($1.j)+2*sl($3.j)+3*sl($$.j)+strlen($1.ar[idxBB])+strlen($3.ar[idxBB])+23)*sizeof(char));
      sprintf($$.ar[idxBB],"pop_v(v%d); v%d_=v%d_; v%d_=v%d_;\n%s%s",$$.j,$1.j,$$.j,$3.j,$$.j,$3.ar[idxBB],$1.ar[idxBB]);
      free($1.ar[idxBB]); free($3.ar[idxBB]);
  }
  | SIN '(' expression ')'
  {
    $$.j=c++; if (c>cmax) cmax=c; 
    $$.af=(char*)malloc((strlen($3.af)+2*sl($$.j)+sl($3.j)+22)*sizeof(char)); 
    sprintf($$.af,"%spush_v(v%d); v%d=sin(v%d);\n",$3.af,$$.j,$$.j,$3.j);
    free($3.af);

    $$.ar[idxBB]=(char*)malloc((2*sl($$.j)+2*sl($3.j)+strlen($3.ar[idxBB])+25)*sizeof(char));
    sprintf($$.ar[idxBB],"pop_v(v%d); v%d_=cos(v%d)*v%d_;\n%s",$$.j,$3.j,$3.j,$$.j,$3.ar[idxBB]);
    free($3.ar[idxBB]);
  }
  | VARREF 
  {
    $$.j=c++; if (c>cmax) cmax=c; 
    $$.af=(char*)malloc((2*sl($$.j)+strlen($1.af)+16)*sizeof(char)); 
    sprintf($$.af,"push_v(v%d); v%d=%s;\n",$$.j,$$.j,$1.af);

    $$.ar[idxBB]=(char*)malloc((strlen($1.af)+2*sl($$.j)+18)*sizeof(char));
    sprintf($$.ar[idxBB],"pop_v(v%d); %s_+=v%d_;\n",$$.j,$1.af,$$.j);
    free($1.af);
  }
  | CONSTANT
  {
    $$.j=c++; if (c>cmax) cmax=c; 
    $$.af=(char*)malloc((2*sl($$.j)+strlen($1.af)+16)*sizeof(char)); 
    sprintf($$.af,"push_v(v%d); v%d=%s;\n",$$.j,$$.j,$1.af);

    $$.ar[idxBB]=(char*)malloc((sl($$.j)+11)*sizeof(char));
    sprintf($$.ar[idxBB],"pop_v(v%d);\n",$$.j);
    free($1.af);
  }
  ;

%%

int yyerror(char *msg) { printf("ERROR: %s \n",msg); return -1; }

int main(int argc,char** argv)
{
  FILE *source_file=fopen(argv[1],"r");
  lexinit(source_file); 
  yyparse();
  fclose(source_file);
  return 0;
}

