%{ 
#include "ast.h"
#include "parser.tab.h"

#include<stdlib.h> // malloc
#include<string.h> // strcpy

/*
extern size_t strlen(const char*); // size_t = unsigned int
extern char* strcpy(char*,const char*);
*/

%}

whitespace      [ \t\n]+
symbol		[a-z]
const		[0-9]

%%

{whitespace} { }
"if" { return IF; }
"while"	{ return WHILE;	} 
"sin" { return SIN; } 
{symbol} {
  yylval.af = (char*)malloc(2*sizeof(char));
  strcpy(yylval.af,yytext);
  int i;
  for (i=0;i<maxBB;i++) yylval.ar[i]=0; 
  yylval.j=0;
  return VARREF;			
}
{const} {
  yylval.af = (char*)malloc((strlen(yytext)+1)*sizeof(char));
  strcpy(yylval.af,yytext);
  int i;
  for (i=0;i<maxBB;i++) yylval.ar[i]=0; 
  yylval.j=0;
  return CONSTANT;
}

. { return yytext[0]; }

%%

void lexinit(FILE *source)
{
  yyin=source;
}
