#include <cmath>
#include <iostream>
#include <stack>

using namespace std;

static stack<double> stack_v;
static stack<int> stack_c;

void push_v(double v) {
  stack_v.push(v);
}
void pop_v(double& v) {
  v=stack_v.top();
  stack_v.pop();
}
void push_c(int c) {
  stack_c.push(c);
}
int pop_c(int& c) {
  if (!stack_c.empty()) {
    c=stack_c.top();
    stack_c.pop();
    return 1;
  }
  return 0;
}

void test ( double &x, double y) {
double t;
#include "test.in"
}

void test_ ( double &x, double& x_, double y, double& y_) {
double t,t_;
#include "test.out"
}

int main() {
{
  cout << "finite differences:" << endl;
  double h=1e-6, x=1, y=2, x_=x+h, y_=y;
  test(x,y);
  test(x_,y_);
  cout << "dx/dx=" << (x_-x)/h << endl;

  x=1, x_=x, y_=y+h;
  test(x,y);
  test(x_,y_);
  cout << "dx/dy=" << (x_-x)/h << endl;
}
{
  cout << "adjoint code:" << endl;
  double x=1, y=2, x_=1., y_=0.;
  test_(x,x_,y,y_); 
  cout << "dx/dx=" << x_ << endl;
  cout << "dx/dy=" << y_ << endl;
}
  return 0;
}
